"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var const_1 = require("./const");
var keys = Object.keys;
exports.getRelationOfKeySets = function (a, b, aKeys, bKeys) {
    if (aKeys === void 0) { aKeys = keys(a); }
    if (bKeys === void 0) { bKeys = keys(b); }
    var aLen = aKeys.length;
    var bLen = bKeys.length;
    if (aLen === 0) {
        if (bLen === 0) {
            return const_1.DisjointEqual;
        }
        return const_1.Subset;
    }
    if (bLen === 0) {
        return const_1.Superset;
    }
    var intersects = 0;
    var aOnly = 0;
    var bOnly = 0;
    if (aLen <= bLen) {
        for (var i = 0; i < aLen; i += 1) {
            if (b[aKeys[i]] === 1) {
                intersects = 1;
                if (aOnly === 1) {
                    break;
                }
            }
            else {
                aOnly = 1;
                if (intersects === 1) {
                    break;
                }
            }
        }
        if (intersects === 0) {
            return const_1.Disjoint;
        }
        for (var i = 0; i < bLen; i += 1) {
            if (a[bKeys[i]] !== 1) {
                bOnly = 1;
                break;
            }
        }
    }
    else {
        for (var i = 0; i < bLen; i += 1) {
            if (a[bKeys[i]] === 1) {
                intersects = 1;
                if (bOnly === 1) {
                    break;
                }
            }
            else {
                bOnly = 1;
                if (intersects === 1) {
                    break;
                }
            }
        }
        if (intersects === 0) {
            return const_1.Disjoint;
        }
        for (var i = 0; i < aLen; i += 1) {
            if (b[aKeys[i]] !== 1) {
                aOnly = 1;
                break;
            }
        }
    }
    if (aOnly === 1) {
        if (bOnly === 1) {
            return const_1.Intersecting;
        }
        return const_1.IntersectingSuperset;
    }
    if (bOnly === 1) {
        return const_1.IntersectingSubset;
    }
    return const_1.IntersectingEqual;
};
//# sourceMappingURL=getRelationOfKeySets.js.map