"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const const_1 = require("./const");
const { keys } = Object;
exports.getRelationOfKeySets = (a, b, aKeys = keys(a), bKeys = keys(b)) => {
    const aLen = aKeys.length;
    const bLen = bKeys.length;
    if (aLen === 0) {
        if (bLen === 0) {
            return const_1.DisjointEqual;
        }
        return const_1.Subset;
    }
    if (bLen === 0) {
        return const_1.Superset;
    }
    let intersects = 0;
    let aOnly = 0;
    let bOnly = 0;
    if (aLen <= bLen) {
        for (let i = 0; i < aLen; i += 1) {
            if (b[aKeys[i]] === 1) {
                intersects = 1;
                if (aOnly === 1) {
                    break;
                }
            }
            else {
                aOnly = 1;
                if (intersects === 1) {
                    break;
                }
            }
        }
        if (intersects === 0) {
            return const_1.Disjoint;
        }
        for (let i = 0; i < bLen; i += 1) {
            if (a[bKeys[i]] !== 1) {
                bOnly = 1;
                break;
            }
        }
    }
    else {
        for (let i = 0; i < bLen; i += 1) {
            if (a[bKeys[i]] === 1) {
                intersects = 1;
                if (bOnly === 1) {
                    break;
                }
            }
            else {
                bOnly = 1;
                if (intersects === 1) {
                    break;
                }
            }
        }
        if (intersects === 0) {
            return const_1.Disjoint;
        }
        for (let i = 0; i < aLen; i += 1) {
            if (b[aKeys[i]] !== 1) {
                aOnly = 1;
                break;
            }
        }
    }
    if (aOnly === 1) {
        if (bOnly === 1) {
            return const_1.Intersecting;
        }
        return const_1.IntersectingSuperset;
    }
    if (bOnly === 1) {
        return const_1.IntersectingSubset;
    }
    return const_1.IntersectingEqual;
};
//# sourceMappingURL=getRelationOfKeySets.js.map