export const Disjoint = 0;
export const Intersecting = 1 << 0;
export const Subset = 1 << 1;
export const Superset = 1 << 2;
export const IntersectingSubset = Intersecting | Subset;
export const IntersectingSuperset = Intersecting | Superset;
export const Equal = Subset | Superset;
export const IntersectingEqual = Intersecting | Equal;
export const DisjointEqual = Disjoint | Equal;
export const FiniteToComplement = {
    [Disjoint]: Intersecting | Subset,
    [Intersecting]: Intersecting,
    [Subset]: Subset,
    [Subset | Intersecting]: Disjoint,
    [Superset]: Intersecting | Subset,
    [Superset | Intersecting]: Intersecting,
    [Superset | Subset]: Subset,
    [Superset | Subset | Intersecting]: Disjoint,
};
export const ComplementToFinite = {
    [Disjoint]: Intersecting | Superset,
    [Intersecting]: Intersecting,
    [Subset]: Intersecting | Superset,
    [Subset | Intersecting]: Intersecting,
    [Superset]: Superset,
    [Superset | Intersecting]: Disjoint,
    [Superset | Subset]: Superset,
    [Superset | Subset | Intersecting]: Disjoint,
};
export const ComplementToComplement = {
    [Disjoint]: Intersecting,
    [Intersecting]: Intersecting,
    [Subset]: Intersecting | Superset,
    [Subset | Intersecting]: Intersecting | Superset,
    [Superset]: Intersecting | Subset,
    [Superset | Intersecting]: Intersecting | Subset,
    [Superset | Subset]: Intersecting | Subset | Superset,
    [Superset | Subset | Intersecting]: Intersecting | Subset | Superset,
};
//# sourceMappingURL=const.js.map